<?php namespace App\Models;

use App\Entities\Especie\Especie;
use App\Utils\DateUtils;

class EspecieModel extends ModelEntity
{
    protected $table = 'especie';
    protected $primaryKey = 'id';
    protected $returnType = 'array';
    protected $allowedFields = [
        'nome'
    ];
    protected $useSoftDeletes = false;
    protected $skipValidation = true;
    protected $useTimestamps = false;
//    protected $createdField  = 'criado_em';
//    protected $updatedField  = 'alterado_em';

    public function registerEspecie (Especie $especie) : void {
        $data = $especie->toArray(true);
        $id_especie = $this->insert($data);
        $especie->setId($id_especie);
    }

    public function updateEspecieByID (int $id_especie, Especie $especie) : bool {
        $data = $especie->toArray(true);
        $binds = ['id_especie' => $id_especie];
        $sets = $this->generateUpdateSets($data, $binds);
        $sql = "UPDATE especie $sets WHERE especie.id = :id_especie:";
        $query = $this->db->query($sql, $binds);
        return $query->connID->affected_rows === 1;
    }
}
